From f81c87ce2203eda8a5f536419e15899fb128980c Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Mon, 22 Jul 2019 17:56:09 -0400
Subject: [PATCH 14/31] split original aphedox SquadRequestType's into two
 different enumerations, one for Request and the other for Response; added
 functionality for more squad interactions; squad favorites, excepting the
 ability to actually load them onto one's client; extensive comments about
 SquadResponseMessage events

---
 .../psforever/objects/loadouts/Loadout.scala  |   3 +-
 .../objects/loadouts/SquadLoadout.scala       |   5 +-
 .../psforever/objects/teamwork/Squad.scala    |   2 +-
 .../game/ReplicationStreamMessage.scala       |  20 +-
 .../game/SquadDefinitionActionMessage.scala   | 110 ++-
 .../SquadDetailDefinitionUpdateMessage.scala  |  36 +-
 .../packet/game/SquadMembershipResponse.scala |  60 +-
 .../psforever/types/SquadRequestType.scala    |  37 +-
 .../psforever/types/SquadResponseType.scala   |  33 +
 .../services/teamwork/SquadResponse.scala     |  18 +-
 .../services/teamwork/SquadService.scala      | 708 +++++++++++++-----
 .../SquadDefinitionActionMessageTest.scala    |  16 +-
 .../src/main/scala/WorldSessionActor.scala    |  65 +-
 13 files changed, 820 insertions(+), 293 deletions(-)
 create mode 100644 common/src/main/scala/net/psforever/types/SquadResponseType.scala

diff --git a/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala
index 58490f60..64668c4e 100644
--- a/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala
+++ b/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala
@@ -23,7 +23,7 @@ object Loadout {
     owner match {
       case p : Player => Success(Create(p, label))
       case v : Vehicle => Success(Create(v, label))
-      case s : Squad => Success(Create(s, label))
+      case s : Squad => Success(Create(s, s.Task))
       case _ => Failure(new MatchError(s"can not create a loadout based on the (current status of) $owner"))
     }
   }
@@ -65,7 +65,6 @@ object Loadout {
   def Create(squad : Squad, label : String) : Loadout = {
     SquadLoadout(
       label,
-      squad.Task,
       if(squad.CustomZoneId) { Some(squad.ZoneId) } else { None },
       squad.Membership
         .zipWithIndex
diff --git a/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala
index 9039c5a0..029c58b7 100644
--- a/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala
+++ b/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala
@@ -5,7 +5,6 @@ import net.psforever.types.CertificationType
 
 final case class SquadPositionLoadout(index : Int, role : String, orders : String, requirements : Set[CertificationType.Value])
 
-final case class SquadLoadout(label : String,
-                              task : String,
+final case class SquadLoadout(task : String,
                               zone_id : Option[Int],
-                              members : List[SquadPositionLoadout]) extends Loadout(label)
+                              members : List[SquadPositionLoadout]) extends Loadout(task)
diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
index b5e5d81d..5f653dcd 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
@@ -91,7 +91,7 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
     }
   }
 
-  def Size : Int = membership.count(member => !member.Name.equals(""))
+  def Size : Int = membership.count(member => member.CharId != 0)
 
   def Capacity : Int = availability.count(open => open)
 }
diff --git a/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala b/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala
index 233f5a59..c34a057c 100644
--- a/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala
@@ -51,6 +51,22 @@ final case class SquadInfo(leader : Option[String],
       squad_guid.orElse(info.squad_guid)
     )
   }
+
+  //methods intended to combine the fields of itself and another object
+  def Leader(leader : String) : SquadInfo =
+    this And SquadInfo(Some(leader), None, None, None, None, None)
+  def Task(task : String) : SquadInfo =
+    this And SquadInfo(None, Some(task), None, None, None, None)
+  def ZoneId(zone : PlanetSideZoneID) : SquadInfo =
+    this And SquadInfo(None, None, Some(zone), None, None, None)
+  def ZoneId(zone : Option[PlanetSideZoneID]) : SquadInfo = zone match {
+    case Some(zoneId) => this And SquadInfo(None, None, zone, None, None, None)
+    case None => SquadInfo(leader, task, zone, size, capacity, squad_guid)
+  }
+  def Size(sz : Int) : SquadInfo =
+    this And SquadInfo(None, None, None, Some(sz), None, None)
+  def Capacity(cap : Int) : SquadInfo =
+    this And SquadInfo(None, None, None, None, Some(cap), None)
 }
 
 /**
@@ -117,7 +133,9 @@ object SquadInfo {
   /**
     * An entry where no fields are defined.
     */
-  final val Blank = SquadInfo(None, None, None, None, None)
+  final val Blank = SquadInfo()
+
+  def apply() : SquadInfo = SquadInfo(None, None, None, None, None, None)
 
   /**
     * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the fields.<br>
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 7b9b4647..32bbc68e 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -20,18 +20,24 @@ object SquadAction{
 
   final case class AnswerSquadJoinRequest() extends SquadAction(1)
 
-  final case class SaveSquadDefinition() extends SquadAction(3)
+  final case class SaveSquadFavorite() extends SquadAction(3)
 
-  final case class LoadSquadDefinition() extends SquadAction(4)
+  final case class LoadSquadFavorite() extends SquadAction(4)
 
-  final case class ListSquadDefinition(name : String) extends SquadAction(7)
+  final case class DeleteSquadFavorite() extends SquadAction(5)
 
-  final case class ListSquad() extends SquadAction(8)
+  final case class ListSquadFavorite(name : String) extends SquadAction(7)
+
+  final case class RequestListSquad() extends SquadAction(8)
+
+  final case class StopListSquad() extends SquadAction(9)
 
   final case class SelectRoleForYourself(state : Int) extends SquadAction(10)
 
   final case class CancelSelectRoleForYourself(value: Long = 0) extends SquadAction(15)
 
+  final case class SetListSquad() extends SquadAction(17)
+
   final case class ChangeSquadPurpose(purpose : String) extends SquadAction(19)
 
   final case class ChangeSquadZone(zone : PlanetSideZoneID) extends SquadAction(20)
@@ -56,12 +62,21 @@ object SquadAction{
 
   final case class CancelSquadSearch() extends SquadAction(35)
 
+  final case class AssignSquadMemberToRole(position : Int, char_id : Long) extends SquadAction(38)
+
   final case class FindLfsSoldiersForRole(state : Int) extends SquadAction(40)
 
   final case class CancelFind() extends SquadAction(41)
 
   final case class Unknown(badCode : Int, data : BitVector) extends SquadAction(badCode)
 
+  object Unknown {
+    import scodec.bits._
+    val StandardBits : BitVector = hex"00".toBitVector.take(6)
+
+    def apply(badCode : Int) : Unknown = Unknown(badCode, StandardBits)
+  }
+
   /**
     * The `Codec`s used to transform the input stream into the context of a specific action
     * and extract the field data from that stream.
@@ -83,31 +98,45 @@ object SquadAction{
       }
     )
 
-    val saveSquadDefinitionCodec = everFailCondition.xmap[SaveSquadDefinition] (
-      _ => SaveSquadDefinition(),
+    val saveSquadFavoriteCodec = everFailCondition.xmap[SaveSquadFavorite] (
+      _ => SaveSquadFavorite(),
       {
-        case SaveSquadDefinition() => None
+        case SaveSquadFavorite() => None
       }
     )
 
-    val loadSquadDefinitionCodec = everFailCondition.xmap[LoadSquadDefinition] (
-      _ => LoadSquadDefinition(),
+    val loadSquadFavoriteCodec = everFailCondition.xmap[LoadSquadFavorite] (
+      _ => LoadSquadFavorite(),
       {
-        case LoadSquadDefinition() => None
+        case LoadSquadFavorite() => None
       }
     )
 
-    val listSquadDefinitionCodec = PacketHelpers.encodedWideStringAligned(6).xmap[ListSquadDefinition] (
-      text => ListSquadDefinition(text),
+    val deleteSquadFavoriteCodec = everFailCondition.xmap[DeleteSquadFavorite] (
+      _ => DeleteSquadFavorite(),
       {
-        case ListSquadDefinition(text) => text
+        case DeleteSquadFavorite() => None
       }
     )
 
-    val listSquadCodec = everFailCondition.xmap[ListSquad] (
-      _ => ListSquad(),
+    val listSquadFavoriteCodec = PacketHelpers.encodedWideStringAligned(6).xmap[ListSquadFavorite] (
+      text => ListSquadFavorite(text),
       {
-        case ListSquad() => None
+        case ListSquadFavorite(text) => text
+      }
+    )
+
+    val requestListSquadCodec = everFailCondition.xmap[RequestListSquad] (
+      _ => RequestListSquad(),
+      {
+        case RequestListSquad() => None
+      }
+    )
+
+    val stopListSquadCodec = everFailCondition.xmap[StopListSquad] (
+      _ => StopListSquad(),
+      {
+        case StopListSquad() => None
       }
     )
 
@@ -125,6 +154,13 @@ object SquadAction{
       }
     )
 
+    val setListSquadCodec = everFailCondition.xmap[SetListSquad] (
+      _ => SetListSquad(),
+      {
+        case SetListSquad() => None
+      }
+    )
+
     val changeSquadPurposeCodec = PacketHelpers.encodedWideStringAligned(6).xmap[ChangeSquadPurpose] (
       purpose => ChangeSquadPurpose(purpose),
       {
@@ -223,6 +259,15 @@ object SquadAction{
       }
     )
 
+    val assignSquadMemberToRoleCodec = (uint4 :: uint32L).xmap[AssignSquadMemberToRole] (
+      {
+        case u1 :: u2 :: HNil => AssignSquadMemberToRole(u1, u2)
+      },
+      {
+        case AssignSquadMemberToRole(u1, u2) => u1 :: u2 :: HNil
+      }
+    )
+
     val findLfsSoldiersForRoleCodec = uint4.xmap[FindLfsSoldiersForRole] (
       state => FindLfsSoldiersForRole(state),
       {
@@ -270,13 +315,14 @@ object SquadAction{
   * &nbsp;&nbsp;&nbsp;&nbsp;`0 ` - Display Squad<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`1 ` - Answer Squad Join Request<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`2 ` - UNKNOWN<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`3 ` - Save Squad Definition<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`4 ` - Load Squad Definition<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`3 ` - Save Squad Favorite<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`4 ` - Load Squad Favorite<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`5 ` - Delete Squad Favorite<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`6 ` - UNKNOWN<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`8 ` - List Squad<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`9 ` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`8 ` - Request List Squad<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`9 ` - Stop List Squad<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`16` - UNKNOWN<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`17` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`17` - Set List Squad (ui)<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`18` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`26` - Reset All<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`35` - Cancel Squad Search<br>
@@ -302,12 +348,12 @@ object SquadAction{
   * &nbsp;&nbsp;&nbsp;&nbsp;`15` - Select this Role for Yourself<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`37` - UNKNOWN<br>
   * &nbsp;&nbsp;`String`<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`7 ` - List Squad Definition<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`7 ` - List Squad Favorite<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`19` - (Squad leader) Change Squad Purpose<br>
   * &nbsp;&nbsp;`Int :: Long`<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`12` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`25` - (Squad leader) Change Squad Member Requirements - Weapons<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`38` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`38` - Assign Squad Member To Role<br>
   * &nbsp;&nbsp;`Int :: String`<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`23` - (Squad leader) Change Squad Member Requirements - Role<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`24` - (Squad leader) Change Squad Member Requirements - Detailed Orders<br>
@@ -343,12 +389,15 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
     ((code : @switch) match {
       case 0 => displaySquadCodec
       case 1 => answerSquadJoinRequestCodec
-      case 3 => saveSquadDefinitionCodec
-      case 4 => loadSquadDefinitionCodec
-      case 7 => listSquadDefinitionCodec
-      case 8 => listSquadCodec
+      case 3 => saveSquadFavoriteCodec
+      case 4 => loadSquadFavoriteCodec
+      case 5 => deleteSquadFavoriteCodec
+      case 7 => listSquadFavoriteCodec
+      case 8 => requestListSquadCodec
+      case 9 => stopListSquadCodec
       case 10 => selectRoleForYourselfCodec
       case 15 => cancelSelectRoleForYourselfCodec
+      case 17 => setListSquadCodec
       case 19 => changeSquadPurposeCodec
       case 20 => changeSquadZoneCodec
       case 21 => closeSquadMemberPositionCodec
@@ -361,12 +410,13 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 31 => locationFollowsSquadLeadCodec
       case 34 => searchForSquadsWithParticularRoleCodec
       case 35 => cancelSquadSearchCodec
+      case 38 => assignSquadMemberToRoleCodec
       case 40 => findLfsSoldiersForRoleCodec
       case 41 => cancelFindCodec
-      case 2 | 6 | 9 | 11 |
-           12 | 13 | 14 | 16 | 17 |
+      case 2 | 6 | 11 |
+           12 | 13 | 14 | 16 |
            18 | 29 | 30 | 32 | 33 |
-           36 | 37 | 38 | 39 | 42 | 43 => unknownCodec(code)
+           36 | 37 | 39 | 42 | 43 => unknownCodec(code)
       case _ => failureCodec(code)
     }).asInstanceOf[Codec[SquadAction]]
   }
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index 9bda7527..225489b7 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -161,7 +161,21 @@ final case class SquadDetail(unk1 : Option[Int],
       task.orElse(info.task),
       zone_id.orElse(info.zone_id),
       unk7.orElse(info.unk7),
-      member_info.orElse(info.member_info)
+      {
+        (member_info, info.member_info) match {
+          case (Some(info1), Some(info2)) =>
+            //combine the first list with the elements of the second list whose indices not found in the first list
+            val indices = info1.map { _.index }
+            Some(info1 ++ (for {
+              position <- info2
+              if !indices.contains(position.index)
+            } yield position).sortBy(_.index))
+          case (Some(info1), None) =>
+            Some(info1)
+          case (None, _) =>
+            info.member_info
+        }
+      }
     )
   }
 
@@ -269,6 +283,15 @@ object SquadPositionDetail {
     * @return a `SquadPositionDetail` object
     */
   def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(Some(false), Some(role), Some(detailed_orders), Some(requirements), Some(char_id), Some(name))
+
+  object Fields {
+    final val Closed = 0
+    final val Role = 1
+    final val Orders = 2
+    final val CharId = 3
+    final val Name = 4
+    final val Requirements = 5
+  }
 }
 
 object SquadPositionEntry {
@@ -318,6 +341,17 @@ object SquadDetail {
     SquadDetail(None, None, None, None, None, None, None, Some(unk7), None)
   def Members(list : List[SquadPositionEntry]) : SquadDetail =
     SquadDetail(None, None, None, None, None, None, None, None, Some(list))
+
+  object Fields {
+    final val Field1 = 1
+    final val CharId = 2
+    final val Field3 = 3
+    final val Leader = 4
+    final val Task = 5
+    final val ZoneId = 6
+    final val Field7 = 7
+    final val Members = 8
+  }
 }
 
 object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefinitionUpdateMessage] {
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadMembershipResponse.scala b/common/src/main/scala/net/psforever/packet/game/SquadMembershipResponse.scala
index ee1746dd..a9f03518 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadMembershipResponse.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadMembershipResponse.scala
@@ -2,12 +2,12 @@
 package net.psforever.packet.game
 
 import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
-import net.psforever.types.SquadRequestType
+import net.psforever.types.SquadResponseType
 import scodec.Codec
 import scodec.codecs._
 
 /**
-  * Dispatched by the server as manipulation protocol for squad and platoon members.
+  * Dispatched by the server as message generation protocol for squad and platoon members.
   * Prompted by and answers for a `SquadMembershipRequest` packet.
   * @param request_type the purpose of the request
   * @param unk1 na
@@ -17,11 +17,57 @@ import scodec.codecs._
   * @param other_id another squad member's unique identifier;
   *                 may be the same as `char_id`
   * @param player_name name of the player being affected, if applicable
-  * @param unk5 na
+  * @param unk5 adjusts the nature of the request-type response based on the message recipient
   * @param unk6 na;
   *             the internal field, the `Option[String]`, never seems to be set
+  * <br>
+  * `request_type` (enum value) / `unk5` state (`false`/`true`)<br>
+  * ----------------------------------------<br>
+  *  - `Invite` (0)<br>
+  * false => [PROMPT] "`player_name` has invited you into a squad." [YES/NO]<br>
+  * true => "You have invited `player_name` to join your squad."<br>
+  *  - `Unk01` (1)<br>
+  * false => n/a<br>
+  * true => n/a<br>
+  *  - `Accept` (2)<br>
+  * false => "`player_name` has accepted your invitation to join into your squad.<br>
+  *   "You have formed a squad and are now that squad's commander." (if first time)<br>
+  * true => "You have accepted an invitation to join a squad."<br>
+  *   "You have successfully joined a squad for the first time." (if first time)<br>
+  *  - `Reject` (3)<br>
+  * false => "`player_name` does not want to join your squad at this time."<br>
+  * true => "You have declined an invitation to join a squad."<br>
+  *  - `Cancel` (4)<br>
+  * false => "`player_name` has withdrawn his invitation."<br>
+  * true => "You have canceled your invitation to `player_name`."<br>
+  *  - `Leave` (5)<br>
+  * false => "The Squad Leader has kicked you out of the squad."<br>
+  * true => "You have kicked `player_name` out of the squad."<br>
+  *  - `Disband` (6)<br>
+  * false => "The squad has been disbanded."<br>
+  * true => "You have disbanded the squad."<br>
+  *  - `PlatoonInvite` (7)<br>
+  * false => [PROMPT] "`player_name` has invited you into a platoon." [YES/NO]<br>
+  * true => "You have invited `player_name`'s squad to join your platoon."<br>
+  *  - `PlatoonAccept` (8)
+  * false => "`player_name` has accepted your invitation to join into your platoon.<br>
+  *   "You have formed a platoon and are now that platoon commander." (if first time)<br>
+  * true => "You have accepted an invitation to join a platoon."<br>
+  *   "You have successfully joined a platoon for the first time." (if first time)<br>
+  *  - `PlatoonReject` (9)<br>
+  * false => "`player_name` does not want to join your platoon at this time."<br>
+  * true => "You have declined an invitation to join a platoon."<br>
+  *  - `PlatoonCancel` (10)<br>
+  * false => "`player_name` has withdrawn his invitation."<br>
+  * true => "You have declined your invitation to `player_name`." (nonsense?)<br>
+  *  - `PlatoonLeave` (11)<br>
+  * false => "The Platoon Leader has kicked you out of the platoon."<br>
+  * true => "You have kicked `player_name`'s squad out of the platoon."<br>
+  *  - `PlatoonDisband` (12)<br>
+  * false => "The platoon has been disbanded."<br>
+  * true => "You have disbanded the platoon."
   */
-final case class SquadMembershipResponse(request_type : SquadRequestType.Value,
+final case class SquadMembershipResponse(request_type : SquadResponseType.Value,
                                          unk1 : Int,
                                          unk2 : Int,
                                          char_id : Long,
@@ -37,14 +83,14 @@ final case class SquadMembershipResponse(request_type : SquadRequestType.Value,
 
 object SquadMembershipResponse extends Marshallable[SquadMembershipResponse] {
   implicit val codec : Codec[SquadMembershipResponse] = (
-    "request_type" | SquadRequestType.codec >>:~ { d =>
+    "request_type" | SquadResponseType.codec >>:~ { d =>
       ("unk1" | uint(5)) ::
         ("unk2" | uint2) ::
         ("char_id" | uint32L) ::
-        ("other_id" | conditional(d != SquadRequestType.Promote && d != SquadRequestType.PlatoonLeave, uint32L)) ::
+        ("other_id" | conditional(d != SquadResponseType.Disband && d != SquadResponseType.PlatoonDisband, uint32L)) ::
         ("player_name" | PacketHelpers.encodedWideStringAligned(5)) ::
         ("unk5" | bool) ::
-        conditional(d != SquadRequestType.Invite, optional(bool, "unk6" | PacketHelpers.encodedWideStringAligned(6)))
+        conditional(d != SquadResponseType.Invite, optional(bool, "unk6" | PacketHelpers.encodedWideStringAligned(6)))
     }
     ).as[SquadMembershipResponse]
 }
diff --git a/common/src/main/scala/net/psforever/types/SquadRequestType.scala b/common/src/main/scala/net/psforever/types/SquadRequestType.scala
index 8d7e2435..1b22bc38 100644
--- a/common/src/main/scala/net/psforever/types/SquadRequestType.scala
+++ b/common/src/main/scala/net/psforever/types/SquadRequestType.scala
@@ -7,23 +7,28 @@ import scodec.codecs._
 object SquadRequestType extends Enumeration {
   type Type = Value
   val
-  Invite,   //00
-  Unk01,    //01
-  Accept,   //02
-  Reject,   //03
-  Cancel,   //04
-  Leave,    //05
-  Promote,  //06
-  Disband,  //07
-  PlatoonInvite,  //08
-  PlatoonAccept,  //09
-  PlatoonReject,  //10
-  PlatoonCancel,  //11
-  PlatoonLeave,   //12
-  PlatoonDisband, //13
-  Unk14,    //14
-  Unk15     //15
+  Invite,
+  Unk01,
+  Accept,
+  Reject,
+  Cancel,
+  Leave,
+  Promote,
+  Disband,
+  PlatoonInvite,
+  PlatoonAccept,
+  PlatoonReject,
+  PlatoonCancel,
+  PlatoonLeave,
+  PlatoonDisband
   = Value
 
   implicit val codec = PacketHelpers.createEnumerationCodec(this, uint4L)
+
+  def toResponse(request : SquadRequestType.Value) : SquadResponseType.Value = {
+    val id = request.id
+    if(id < 6) SquadResponseType(id)
+    else if(id > 6) SquadResponseType(id - 1)
+    else throw new NoSuchElementException("request does not have an applicable response")
+  }
 }
diff --git a/common/src/main/scala/net/psforever/types/SquadResponseType.scala b/common/src/main/scala/net/psforever/types/SquadResponseType.scala
new file mode 100644
index 00000000..1f73ccc4
--- /dev/null
+++ b/common/src/main/scala/net/psforever/types/SquadResponseType.scala
@@ -0,0 +1,33 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.types
+
+import net.psforever.packet.PacketHelpers
+import scodec.codecs._
+
+object SquadResponseType extends Enumeration {
+  type Type = Value
+  val
+  Invite,
+  Unk01,
+  Accept,
+  Reject,
+  Cancel,
+  Leave,
+  Disband,
+  PlatoonInvite,
+  PlatoonAccept,
+  PlatoonReject,
+  PlatoonCancel,
+  PlatoonLeave,
+  PlatoonDisband
+  = Value
+
+  implicit val codec = PacketHelpers.createEnumerationCodec(this, uint4L)
+
+  def fromRequest(response : SquadResponseType.Value) : SquadRequestType.Value = {
+    val id = response.id
+    if(id < 6) SquadRequestType(id)
+    else if(id > 5) SquadRequestType(id + 1)
+    else throw new NoSuchElementException("response does not stem from an applicable request")
+  }
+}
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index e1ab03cb..b74f153f 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -1,21 +1,27 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import net.psforever.objects.teamwork.{Member, Squad}
+import net.psforever.objects.teamwork.Squad
 import net.psforever.packet.game._
-import net.psforever.types.SquadRequestType
+import net.psforever.types.SquadResponseType
 
 object SquadResponse {
   trait Response
 
-  final case class Init(info : Vector[SquadInfo]) extends Response
-  final case class Update(infos : Iterable[(Int, SquadInfo)]) extends Response
-  final case class Remove(infos : Iterable[Int]) extends Response
+  final case class ListSquadFavorite(line : Int, task : String) extends Response
 
-  final case class Membership(request_type : SquadRequestType.Value, unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Option[Long], player_name : String, unk5 : Boolean, unk6 : Option[Option[String]]) extends Response //see SquadMembershipResponse
+  final case class InitList(info : Vector[SquadInfo]) extends Response
+  final case class UpdateList(infos : Iterable[(Int, SquadInfo)]) extends Response
+  final case class RemoveFromList(infos : Iterable[Int]) extends Response
+
+  final case class InitSquad(squad_guid : PlanetSideGUID) extends Response
+  final case class Unknown17(squad : Squad, char_id : Long) extends Response
+  final case class Membership(request_type : SquadResponseType.Value, unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Option[Long], player_name : String, unk5 : Boolean, unk6 : Option[Option[String]]) extends Response //see SquadMembershipResponse
+  final case class Invite(from_char_id : Long, to_char_id : Long, name : String) extends Response
   final case class Join(squad : Squad, positionsToUpdate : List[Int]) extends Response
   final case class Leave(squad : Squad, positionsToUpdate : List[(Long, Int)]) extends Response
   final case class UpdateMembers(squad : Squad, update_info : List[SquadAction.Update]) extends Response
+  final case class SwapMember(squad : Squad, from_index : Int, to_index : Int) extends Response
 
   final case class Detail(guid : PlanetSideGUID, leader : String, task : String, zone : PlanetSideZoneID, member_info : List[SquadPositionDetail]) extends Response
 }
